<!DOCTYPE HTML>
<!-- NewPage -->
<html lang="fr">
<head>
<!-- Generated by javadoc (11.0.7) on Wed Oct 07 11:48:50 CEST 2020 -->
<title>OCAPackageDeclarationsAndImports</title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta name="dc.created" content="2020-10-07">
<link rel="stylesheet" type="text/css" href="../../stylesheet.css" title="Style">
<link rel="stylesheet" type="text/css" href="../../jquery/jquery-ui.css" title="Style">
<script type="text/javascript" src="../../script.js"></script>
<script type="text/javascript" src="../../jquery/jszip/dist/jszip.min.js"></script>
<script type="text/javascript" src="../../jquery/jszip-utils/dist/jszip-utils.min.js"></script>
<!--[if IE]>
<script type="text/javascript" src="../../jquery/jszip-utils/dist/jszip-utils-ie.min.js"></script>
<![endif]-->
<script type="text/javascript" src="../../jquery/jquery-3.4.1.js"></script>
<script type="text/javascript" src="../../jquery/jquery-ui.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="OCAPackageDeclarationsAndImports";
        }
    }
    catch(err) {
    }
//-->
var data = {"i0":10,"i1":10,"i2":10,"i3":10,"i4":10,"i5":10,"i6":10,"i7":10,"i8":10};
var tabs = {65535:["t0","All Methods"],2:["t2","Instance Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
var pathtoroot = "../../";
var useModuleDirectories = true;
loadScripts(document, 'script');</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<header role="banner">
<nav role="navigation">
<div class="fixedNav">
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a id="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a id="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../index-all.html">Index</a></li>
<li><a href="../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../allclasses.html">All&nbsp;Classes</a></li>
</ul>
<ul class="navListSearch">
<li><label for="search">SEARCH:</label>
<input type="text" id="search" value="search" disabled="disabled">
<input type="reset" id="reset" value="reset" disabled="disabled">
</li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a id="skip.navbar.top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
</div>
<div class="navPadding">&nbsp;</div>
<script type="text/javascript"><!--
$('.navPadding').css('padding-top', $('.fixedNav').css("height"));
//-->
</script>
</nav>
</header>
<!-- ======== START OF CLASS DATA ======== -->
<main role="main">
<div class="header">
<div class="subTitle"><span class="packageLabelInType">Package</span>&nbsp;<a href="package-summary.html">oca.welcometojava</a></div>
<h2 title="Class OCAPackageDeclarationsAndImports" class="title">Class OCAPackageDeclarationsAndImports</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li>java.lang.Object</li>
<li>
<ul class="inheritance">
<li>oca.welcometojava.OCAPackageDeclarationsAndImports</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<hr>
<pre>public class <span class="typeNameLabel">OCAPackageDeclarationsAndImports</span>
extends java.lang.Object</pre>
<div class="block"><h1>Understanding Package Declarations and Imports</h1></div>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="constructor.summary">
<!--   -->
</a>
<h3>Constructor Summary</h3>
<table class="memberSummary">
<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Constructor</th>
<th class="colLast" scope="col">Description</th>
</tr>
<tr class="altColor">
<th class="colConstructorName" scope="row"><code><span class="memberNameLink"><a href="#%3Cinit%3E()">OCAPackageDeclarationsAndImports</a></span>()</code></th>
<td class="colLast">&nbsp;</td>
</tr>
</table>
</li>
</ul>
</section>
<!-- ========== METHOD SUMMARY =========== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="memberSummary">
<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a href="javascript:show(2);">Instance Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a href="javascript:show(8);">Concrete Methods</a></span><span class="tabEnd">&nbsp;</span></span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colSecond" scope="col">Method</th>
<th class="colLast" scope="col">Description</th>
</tr>
<tr id="i0" class="altColor">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#compilingAndRunningCodeWithPackages()">compilingAndRunningCodeWithPackages</a></span>()</code></th>
<td class="colLast">
<div class="block">Compiling and Running Code with Packages</div>
</td>
</tr>
<tr id="i1" class="rowColor">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#compilingWithJARFiles()">compilingWithJARFiles</a></span>()</code></th>
<td class="colLast">
<div class="block">Compiling with JAR Files</div>
</td>
</tr>
<tr id="i2" class="altColor">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#creatingJARFile()">creatingJARFile</a></span>()</code></th>
<td class="colLast">
<div class="block">Creating a JAR File</div>
</td>
</tr>
<tr id="i3" class="rowColor">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#creatingNewPackage()">creatingNewPackage</a></span>()</code></th>
<td class="colLast">
<div class="block">Creating a New Package</div>
</td>
</tr>
<tr id="i4" class="altColor">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#namingConflicts()">namingConflicts</a></span>()</code></th>
<td class="colLast">
<div class="block">Naming Conflicts</div>
</td>
</tr>
<tr id="i5" class="rowColor">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#redundandImports()">redundandImports</a></span>()</code></th>
<td class="colLast">
<div class="block">Redundand Imports</div>
</td>
</tr>
<tr id="i6" class="altColor">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#runningProgramInOneLineWithPackages()">runningProgramInOneLineWithPackages</a></span>()</code></th>
<td class="colLast">&nbsp;</td>
</tr>
<tr id="i7" class="rowColor">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#usingAlternateDirectory()">usingAlternateDirectory</a></span>()</code></th>
<td class="colLast">
<div class="block">Using an Alternate Directory</div>
</td>
</tr>
<tr id="i8" class="altColor">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#wildcards()">wildcards</a></span>()</code></th>
<td class="colLast">
<div class="block">Wildcards</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a id="methods.inherited.from.class.java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.Object</h3>
<code>clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait</code></li>
</ul>
</li>
</ul>
</section>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="constructor.detail">
<!--   -->
</a>
<h3>Constructor Detail</h3>
<a id="&lt;init&gt;()">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>OCAPackageDeclarationsAndImports</h4>
<pre>public&nbsp;OCAPackageDeclarationsAndImports()</pre>
</li>
</ul>
</li>
</ul>
</section>
<!-- ============ METHOD DETAIL ========== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a id="wildcards()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>wildcards</h4>
<pre class="methodSignature">public&nbsp;void&nbsp;wildcards()</pre>
<div class="block"><h1>Wildcards</h1>
 <p>
 Import all the classes in the same package (ONLY classes, not packages,
 fields or methods).<br/>
 Java compiler imports just what's actually needed.
 </p></div>
</li>
</ul>
<a id="redundandImports()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>redundandImports</h4>
<pre class="methodSignature">public&nbsp;void&nbsp;redundandImports()</pre>
<div class="block"><h1>Redundand Imports</h1>
 <ul>
 <li>A wildcar only matches class names.</li>
 <li>We can only have one wildcard and it must be at the end.</li>
 <li>We cannot import methods only class names.</li>
 </ul></div>
</li>
</ul>
<a id="namingConflicts()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>namingConflicts</h4>
<pre class="methodSignature">public&nbsp;void&nbsp;namingConflicts()</pre>
<div class="block"><h1>Naming Conflicts</h1>
 <p>
 When the class is found in multiple packages, Java gives us a compile error :
 <br/>
 <code>error : reference to 'Class' is ambiguous</code>
 </p>
 <ul>
 <li>Explicit import take precedence over any wildcards present.</li>
 <li>If we need two classes with the same name, we have to use fully qualified
 name for one of them.</li>
 </ul></div>
</li>
</ul>
<a id="creatingNewPackage()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>creatingNewPackage</h4>
<pre class="methodSignature">public&nbsp;void&nbsp;creatingNewPackage()</pre>
<div class="block"><h1>Creating a New Package</h1>
 <p>
 Java packages are related to directory structure on the computer.
 </p></div>
</li>
</ul>
<a id="compilingAndRunningCodeWithPackages()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>compilingAndRunningCodeWithPackages</h4>
<pre class="methodSignature">public&nbsp;void&nbsp;compilingAndRunningCodeWithPackages()</pre>
<div class="block"><h1>Compiling and Running Code with Packages</h1>
 <h2>uses of javac command</h2>
 <ul>
 <li>Use space to separate different classe names to compile.</li>
 <li>Wildcard can be used to specify all java classes in the same
 package.</li>
 <li>Wildcard cannot be used to include subdirectories.</li>
 </ul></div>
</li>
</ul>
<a id="usingAlternateDirectory()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>usingAlternateDirectory</h4>
<pre class="methodSignature">public&nbsp;void&nbsp;usingAlternateDirectory()</pre>
<div class="block"><h1>Using an Alternate Directory</h1>
 <p>
 By default, the javac command places the compiled classes in the same
 directory as the source code.<br/>
 The option <b>-d</b> place the compiled classes into specified directory and
 <b>preserve</b> the package structure.
 </p>
 <h2>javac command options</h2>
 <ul>
 <li><b>-d</b> : Specify compiled classes directory</li>
 <li>Classpath options : Location of classes needed to compile the program.
 <ul>
 <li><code>javac -cp classes packageA/ClassA.java</code></li>
 <li><code>javac -classpath classes packageA/ClassA.java</code></li>
 <li><code>javac --class-path classes packageA/ClassA.java</code></li>
 </ul>
 </li>
 <li><b><code>-m, --module</b> [module-name]</code> : Compile only the
 specified module, check timestamps</li>
 </ul>
 
 <h2>java command options</h2>
 <ul>
 <li>Classpath options : Location of classes needed to run the program.
 <ul>
 <li><code>java -cp classes packageA.ClassA</code></li>
 <li><code>java -classpath classes packageA.ClassA</code></li>
 <li><code>java --class-path classes packageA.ClassA</code></li>
 </ul>
 </li>
 <li><b><code>-p, --module-path</b> [module path]</code> : A <b>;</b> separate
 directory.</li>
 </ul></div>
</li>
</ul>
<a id="compilingWithJARFiles()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>compilingWithJARFiles</h4>
<pre class="methodSignature">public&nbsp;void&nbsp;compilingWithJARFiles()</pre>
<div class="block"><h1>Compiling with JAR Files</h1>
 <p>
 <h2>On windows system</h2>
 <code>java -cp ".;C:\tmp\someOtherLocation;\tmp\myJar.jar" packageA.ClassA</code>
 <h2>On linux system</h2>
 <code>java -cp ".:/tmp/someOtherLocation:/tmp/myJar.jar" packageA.ClassA</code>
 </p></div>
</li>
</ul>
<a id="creatingJARFile()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>creatingJARFile</h4>
<pre class="methodSignature">public&nbsp;void&nbsp;creatingJARFile()</pre>
<div class="block"><h1>Creating a JAR File</h1>
 <h2>Command to create a jar file</h2>
 <ul>
 <li>Create a jar file containing the files in the current directory :
 <ul>
 <li><code>jar -cvf myJar.jar</code></li>
 <li><code>jar --create --verbose --file myJar.jar</code></li></li>
 </ul>
 <li><b>-c, --create</b> : Creates a new JAR file.</li>
 <li><b>-v, --verbose</b> : Prints details when working with JAR files.</li>
 <li><b>-f, --file</b> [file name] : JAR filename.</li>
 <li><b>-C</b> [directory]: Directory containing files to be used to create
 the JAR.</li>
 </ul></div>
</li>
</ul>
<a id="runningProgramInOneLineWithPackages()">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>runningProgramInOneLineWithPackages</h4>
<pre class="methodSignature">public&nbsp;void&nbsp;runningProgramInOneLineWithPackages()</pre>
</li>
</ul>
</li>
</ul>
</section>
</li>
</ul>
</div>
</div>
</main>
<!-- ========= END OF CLASS DATA ========= -->
<footer role="contentinfo">
<nav role="navigation">
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a id="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a id="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../index-all.html">Index</a></li>
<li><a href="../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../allclasses.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a id="skip.navbar.bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</nav>
</footer>
</body>
</html>
